; Splash Screen DLL - Sample 2
;   by QvasiModo (Mario Vilas)
;   27-Aug-03

;This sample shows how to use the splash screen library.
;It loads the library dynamically using LoadLibrary, so if the splash screen is missing the program will still be loaded.

include \masm32\macros\macros.inc

AppModel .386

include \masm32\include\windows.inc

include \masm32\include\kernel32.inc
include Splash.inc

includelib \masm32\lib\kernel32.lib

.const
sz Splash
sz SplashOpen
sz SplashWait
sz SplashClose

.data
hLib            dd 0
pSplashOpen     dd 0
pSplashWait     dd 0
pSplashClose    dd 0

.code
start:

invoke LoadLibrary,offset szSplash                  ;Load the library
test eax,eax
jz @F
mov hLib,eax

invoke GetProcAddress,hLib,offset szSplashOpen      ;Get address of SplashOpen
test eax,eax
jz @F
mov pSplashOpen,eax

invoke GetProcAddress,hLib,offset szSplashWait      ;Get address of SplashWait
test eax,eax
jz @F
mov pSplashWait,eax

invoke GetProcAddress,hLib,offset szSplashClose     ;Get address of SplashClose
test eax,eax
jz @F
mov pSplashClose,eax

push HWND_DESKTOP                                   ;Create and show the splash screen
call pSplashOpen

push INFINITE                                       ;Wait for the user to click on it
call pSplashWait

call pSplashClose                                   ;Close the splash screen

invoke FreeLibrary,hLib                             ;Free the library
@@:

;This is where the rest of your program goes...

invoke ExitProcess,0
end start
